//This Game and code is made by Alex Mendelsberg

///////////////////////////////////////////////////////////////////////////////////
// GameStudio main script
////////////////////////////////////////////////////////////////////////////
// Files to over-ride:
// * logodark.bmp - the engine logo, include your game title
// * horizon.pcx - A horizon map displayed over the sky and cloud maps
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "C:\\Program Files\\GStudio6\\template_6";	// Path to A6 templates directory
path "C:\\Program Files\\GStudio6\\template_6\\code";	// Path to A6 template code subdirectory

path "C:\\Program Files\\GStudio6\\template_6\\models";	// Path to A6 template model subdirectory
path "C:\\program files\\gstudio6\\template";

////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated actions
include <gid01.wdl>;	// global ids
include <display00.wdl>;  // basic display settings

////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.

/////////////////////////////////////////////////////////////////
// Strings and filenames
// change this string to your own starting mission message.

string level_str = <ROLLERCOASTR.WMB>; // give file names in angular brackets

/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap splashmap = <logodark.pcx>; // the default logo in templates
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}

////////////////////////////////////////////////////////////////////////////
// The following script controls the sky

sky horizon_sky {
// A backdrop texture's horizontal size must be a power of 2;
// the vertical size does not matter
	type = <stars.bmp>;
	tilt = 0;
	flags = visible,scene;
	layer = 1;
}
/////////////////////////////////////////////////////////////////
// The main() function is started at game start
bmap rllr=<roller.bmp>;
var phys=1; var play;
panel intro
{bmap=rllr;
pos_y=0;pos_x=0;
flags=transparent;}
bmap rllr2=<roller2.bmp>;
var phys=1; var play;
panel end
{bmap=rllr2;
pos_y=0;pos_x=0;
flags=transparent;}
var dist_planar = 200; // distance from the player
var cam_angle = 0;var dist_traced;var tilt_3rd=30;var dist_total=200;var updown=100;
view 3rd_person
{
layer = 1;
pos_x = 0;
pos_y = 0;
}
function init_cameras()
{
camera.visible = off;
3rd_person.size_x = screen_size.x;
3rd_person.size_y = screen_size.y;

3rd_person.visible = on;
}
var camsw;
function validate_view()
{
my = player;
trace_mode = ignore_me + ignore_passable;
dist_traced = trace (player.x, 3rd_person.x);
if (dist_traced == 0) { return; } // No obstacles hit... fine
if (dist_traced < dist_total&&camsw==0)
{
dist_traced -= 5; // Move it out of the wall
dist_planar = cos (tilt_3rd) * dist_traced;
3rd_person.x = player.x - cos (cam_angle) * dist_planar;
3rd_person.y = player.y - sin (cam_angle) * dist_planar;
3rd_person.z = player.z + sin (tilt_3rd) * dist_traced;
}}
function update_views()
{vec_set(temp,vector(player.x,player.y,0)); 
vec_sub(temp,3rd_person.x);
vec_to_angle(3rd_person.pan,temp);
dist_planar = cos (tilt_3rd) * dist_total;
3rd_person.x = player.x - cos (3rd_person.pan) * dist_planar;
3rd_person.y = player.y - sin (3rd_person.pan) * dist_planar;
3rd_person.z = player.z+updown;
3rd_person.tilt=-asin(updown/vec_dist(3rd_person.x,player.x));
updown+=key_force.y;cam_angle=3rd_person.pan;
validate_view();}


function main()
{max_particles = 5000;
	// set some common flags and variables
	// freeze all entity functions
	freeze_mode = 1;
	// no level has been loaded yet...
	gid01_level_state = gid01_level_not_loaded;

// entry: Warning Level (0,1, or 2)
// entry_help: Sets sensitivity to warnings (0 = none, 1 = some, 2 = all).
	warn_level = 2;	// announce bad texture sizes and bad wdl code

splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on;
// entry: Starting Mouse Mode (0, 1, or 2)
	mouse_mode = 0;

	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// now load the level
	level_load(level_str);

	wait(2);	// let level load
	// level should be loaded at this point...
	gid01_level_state = gid01_level_loaded;

//+++ load starting values

	freeze_mode = 0;
sleep(1);
  	splashscreen.visible = off;
	bmap_purge(splashmap);	// remove splashscreen from video memory

	// main game loop
init_cameras();	intro.pos_x=(screen_size.x - bmap_width(rllr))/2;
intro.pos_y= (screen_size.y - bmap_height(rllr))/2;
end.pos_x=(screen_size.x - bmap_width(rllr))/2;
end.pos_y= (screen_size.y - bmap_height(rllr))/2;
intro.visible=on;
sleep(5);intro.visible=off;play=1;


3rd_person.clip_far=1600;while(1)
	{
		if(gid01_level_state != gid01_level_loaded)
		{
			freeze_mode = 1;  // pause the game
			while(gid01_level_state != gid01_level_loaded) { wait(1); }
			freeze_mode = 0;  // resume the game
		}
		wait(1);
	}

}


// Desc: this is the function used to restart the game.
function	main_restart_game()
{
	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// now load the level
	level_load(level_str);
	// freeze the game
	freeze_mode = 1;

	wait(2);	// 1-level loads, 2-entities load

//+++ load starting values

	// un-freeze the game
	freeze_mode = 0;
}


// Desc: this is the function used to quit the game.
function	main_quit()
{
//+++			// save global skills & strings
	exit;
}

//	client_move();	// for a possible multiplayer game
// call further functions here...
}


/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
WINDOW WINSTART
{
	TITLE			"3D GameStudio";
	SIZE			480,320;
	MODE			IMAGE;	//STANDARD;
	BG_COLOR		RGB(240,240,240);
	FRAME			FTYP1,0,0,480,320;
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	BUTTON		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}

/* no exit window at all..
WINDOW WINEND
{
	TITLE			"Finished";
	SIZE			540,320;
	MODE	 		STANDARD;
	BG_COLOR		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET FONT		"",RGB(0,255,255);
	TEXT			"Any key to exit",10,270;
}*/


/////////////////////////////////////////////////////////////////
//INCLUDE <debug.wdl>;
var game=1;;

bmap strall=<bluel.bmp>; bmap blue=<blue.pcx>;bmap glow=<strall.pcx>;
function part_bigf
{my.alpha-=1;
if(my.alpha<0){my.lifespan=0;
}
}
function part_big
{my.transparent=on;my.alpha=70;my.bmap=blue;my.size=20;my.bright=on; my.function =part_bigf;
}
function part_smallf
{
if(my.z>5000){my.lifespan=0;}
}
function part_small
{my.flare=on;
my.vel_z=80;my.move=on;my.streak=on;my.alpha=100;my.bmap=glow;my.size=5;my.bright=on; my.function =part_bigf;
}
var d1=0;string level_2=<roller2.wmb>;
function reset
{while(MY.Z>-7164){
	wait(1);
}



	

phys=0;my==null;
if(game==1){
level_load(level_str);}
if(game==2){
level_load(level_2);}wait(1);my.x=-2843;my.y=2168;my.z=1991;
}



action roller
{
player=me;


phys=1;
RESET();

my.enable_impact=on;my.enable_block=on;
my.enable_trigger=on;my.trigger_range=10;
phent_settype(my,ph_rigid,ph_sphere);
phent_setmass(my,.8,ph_sphere);
temp.x=0;temp.y=0;temp.z=-306;
ph_setgravity(temp);phent_setfriction(my,20);phent_setelasticity(my,0,0);phent_setdamping ( my, 0, 0 );
while(my!=null){update_views();
effect(part_big,1,my.x,normal);if(phys==1){
if(key_a==1){phent_addcentralforce(my,vector(200*COS(CAM_ANGLE+90),200*SIN(CAM_ANGLE+90),0))*time;}
if(key_d==1){phent_addcentralforce(my,vector(-200*COS(CAM_ANGLE+90),-200*SIN(CAM_ANGLE+90),0))*time;}
if(key_w==1){phent_addcentralforce(my,vector(200*COS(CAM_ANGLE),200*SIN(CAM_ANGLE),0))*time;}
if(key_s==1){phent_addcentralforce(my,vector(-200*COS(CAM_ANGLE),-200*SIN(CAM_ANGLE),0))*time;}
}if(phys==0){phent_settype(my,0,0);break;
}if(phys==2){phent_settype(my,0,0);phys=3;
}
wait(1);
}
}




var elev[3];
function goup()
{if(event_type==event_impact){my.enable_impact=off;
while(player.z<1000){phent_addcentralforce(player,Vector(0,0,500));wait(1);
}my.enable_impact=on;}
}
action jumpup
{my.enable_impact=on;wait(10);my.event=goup;while(1){effect(part_small,7,vector(my.x-random(50)+25,my.y-random(50)+25,my.z),normal);wait(1);
}
}
action btube
{my.transparent=on;my.alpha=60;while(1){my.u+=1*time;wait(1);
}
}
action swing
{wait(my.skill1);while(1){if(vec_dist(vector(my.x,my.y,my.z-300),player.x)<500){
my.roll=sin(my.skill2*2)*30;my.skill2+=1;
}wait(1);}
}
action warp
{wait(10);while(vec_dist(my.x,player.x)>30){wait(1);}phys=0;end.visible=on;

}


function remove_flares() 
{ 
     my.lifespan -= 1; // remove the flare particle 
} 
function attach_flares() 
{ my.lifespan=1;
     my.bmap = glow; 
     my.flare = on; 
     my.bright = on; 
     my.size = 10; 
     my.red=255*(abs(my.x)/16);my.blue=255*(abs(my.y)/16);my.green=255*(abs(my.z)/16); my.light=on;
     my.function = remove_flares; 
} 




function init_vertex() 
{ 
     var vertices; // local var 
     my.invisible = on; 
     while (1) 
     { 
          vertices = ent_vertices (my); 
          while (vertices > 0) 
          { 
               vec_for_vertex (temp, my, vertices); 
               effect (attach_flares, 1, temp, normal); 
               vertices -= 1; 
          } 
          wait (1); 
     } 
} 


action spinthing
{my.passable=on;init_vertex();my.invisible=on;while(1){wait(1);my.pan+=4;my.tilt+=4;
}
}



